libcamera::Object Class Reference

Base object to support automatic signal disconnection. More...

Inheritance diagram for libcamera::Object:

## Public Member Functions

| Object (Object *parent=nullptr)
| Construct an Object instance. More...
virtual | ~Object ()
| Destroy an Object instance. More...
void | postMessage (std::unique_ptr< Message > msg)
| Post a message to the object's thread. More...
template<typename T , typename R , typename... FuncArgs, typename... Args, typename std::enable_if_t< std::is_base_of< Object, T >::value > * = nullptr>
R | invokeMethod (R(T::*func)(FuncArgs...), ConnectionType type, Args... args)
| Invoke a method asynchronously on an Object instance. More...
Thread * | thread () const
| Retrieve the thread the object is bound to. More...
void | moveToThread (Thread *thread)
| Move the object and all its children to a different thread. More...
Object * | parent () const
| Retrieve the object's parent. More...

## Protected Member Functions

virtual void | message (Message *msg)
| Message handler for the object. More...

## Friends

class | SignalBase
class | Thread

## Detailed Description

Base object to support automatic signal disconnection.

The Object class simplifies signal/slot handling for classes implementing slots. By inheriting from Object, an object is automatically disconnected from all connected signals when it gets destroyed.

Object instances are bound to the thread of their parent, or the thread in which they're created when they have no parent. When a message is posted to an object, its handler will run in the object's thread. This allows implementing easy message passing between threads by inheriting from the Object class.

Deleting an object from a thread other than the one the object is bound to is unsafe, unless the caller ensures that the object isn't processing any message concurrently.

Object slots connected to signals will also run in the context of the object's thread, regardless of whether the signal is emitted in the same or in another thread.

See also
  Message, Signal, Thread

## Constructor & Destructor Documentation

## Object()

libcamera::Object::Object | ( | Object * | parent = `nullptr` | ) |

Construct an Object instance.

Parameters

  [in] | parent | The object parent

The new Object instance is bound to the thread of its parent, or to the current thread if the parent is nullptr.

## ~Object()

libcamera::Object::~Object | ( |  | ) |

virtual

Destroy an Object instance.

Deleting an Object automatically disconnects all signals from the Object's slots. All the Object's children are made orphan, but stay bound to their current thread.

## Member Function Documentation

## invokeMethod()

template<typename T , typename R , typename... FuncArgs, typename... Args, typename std::enable_if_t< std::is_base_of< Object, T >::value > * = nullptr>

R libcamera::Object::invokeMethod | ( | R(T::*)(FuncArgs...) | func,
|  | ConnectionType | type,
|  | Args... | args
| ) |  |

inline

Invoke a method asynchronously on an Object instance.

Parameters

  [in] | func | The object method to invoke
  [in] | type | Connection type for method invocation
  [in] | args | The method arguments

This method invokes the member method func with arguments args, based on the connection type. Depending on the type, the method will be called synchronously in the same thread or asynchronously in the object's thread.

Arguments args passed by value or reference are copied, while pointers are passed untouched. The caller shall ensure that any pointer argument remains valid until the method is invoked.

Thread Safety:
  This function is thread-safe.

Returns
  For connection types ConnectionTypeDirect and ConnectionTypeBlocking, return the return value of the invoked method. For connection type ConnectionTypeQueued, return a default-constructed R value.

## message()

void libcamera::Object::message | ( | Message * | msg | ) |

protected virtual

Message handler for the object.

Parameters

  [in] | msg | The message

This virtual method receives messages for the object. It is called in the context of the object's thread, and can be overridden to process custom messages. The parent Object::message() method shall be called for any message not handled by the override method.

The message msg is valid only for the duration of the call, no reference to it shall be kept after this method returns.

Reimplemented in libcamera::Timer, and libcamera::EventNotifier.

## moveToThread()

void libcamera::Object::moveToThread | ( | Thread * | thread | ) |

Move the object and all its children to a different thread.

Parameters

  [in] | thread | The target thread

This method moves the object and all its children from the current thread to the new thread.

Before the object is moved, a Message::ThreadMoveMessage message is sent to it. The message() method can be reimplement in derived classes to be notified of the upcoming thread move and perform any required processing.

Moving an object that has a parent is not allowed, and causes undefined behaviour.

Thread Safety:
  This function is thread-bound.

## parent()

libcamera::Object::parent | ( |  | ) | const

inline

Retrieve the object's parent.

Returns
  The object's parent

## postMessage()

void libcamera::Object::postMessage | ( | std::unique_ptr< Message > | msg | ) |

Post a message to the object's thread.

Parameters

  [in] | msg | The message

This method posts the message msg to the message queue of the object's thread, to be delivered to the object through the message() method in the context of its thread. Message ownership is passed to the thread, and the message will be deleted after being delivered.

Messages are delivered through the thread's event loop. If the thread is not running its event loop the message will not be delivered until the event loop gets started.

Thread Safety:
  This function is thread-safe.

## thread()

libcamera::Object::thread | ( |  | ) | const

inline

Retrieve the thread the object is bound to.

Thread Safety:
  This function is thread-safe.

Returns
  The thread the object is bound to

The documentation for this class was generated from the following files:

- include/libcamera/object.h
- src/libcamera/object.cpp